<?php

declare(strict_types=1);
/**
 * +----------------------------------------------------------------------
 * 后台文章控制制器
 * @author huwhis@163.com
 * @version   0.0.1
 * +----------------------------------------------------------------------
 */

namespace app\sys\controller;

// 引入框架内置类
use think\facade\View;

use app\common\model\Category as CategoryModel;
use app\common\model\Article as ArticleModel;

/**
 * 文章管理  

 */
class Article extends Base
{
    protected $modelName = "Article";

    public function index()
    {
        $categories = CategoryModel::select();

        $category_tree = list_tree($categories);

        $cid = $this->app->request->param('cid');

        $params = $this->app->request->param();

        $list = ArticleModel::queryPage($params);

        View::assign('category_tree', $category_tree);

        View::assign('list', $list);
        View::assign('cid', $cid);
        return View::fetch();
    }

    public function save($content_type = 0, $id = 0)
    {
        if ($this->app->request->isPost()) {
            $params = $this->app->request->param();

            if (!$params['cid']) {
                $this->error('请选择栏目');
            }
            if ($params['title'] == '') {
                $this->error("标题不能为空");
            }

            $params['content'] =  isset($params['content']) ? $params['content'] : '';
            try {
                if ($params['id'] != 0) {
                    ArticleModel::update($params);
                } else {
                    $params['userid'] = $this->getSysUser()->userid;
                    $params['username'] = $this->getSysUser()->username;
                    unset($params['id']);
                    ArticleModel::create($params);
                }
            } catch (\Exception $e) {
                $msg = $e->getMessage();

                $this->error("错误提示:" . $msg);
            }
            $this->success('操作成功', (string) url('index?cid=' . $params['cid']));
        } else {
            if ($id) {
                $data = ArticleModel::find($id);
            } else {
                $data = new ArticleModel();
                $data->content_type = $content_type;
            }

            $categories = CategoryModel::field('id, parent_id, name')->select();

            View::assign('category_tree', list_tree($categories));
            View::assign('data', $data);

            $template = $content_type ? 'savemd' : 'save';

            return View::fetch($template);
        }
    }
}
